import numpy as np
import datetime
import matplotlib.pyplot as plt
from matplotlib import pyplot
import matplotlib.dates as dates
import pandas as pd
from pandas import read_csv
from pandas.tseries.frequencies import to_offset
from datetime import datetime
from scipy import stats

def myfunc(value, slope, intercept):
  return slope * value+ intercept

df = pd.read_csv('iwv_Bern.csv', parse_dates=True, index_col='Date')

dfa=df.resample('Y').mean()     # make annual means of IWV
dfa.index = dfa.index + to_offset('-182D')  # shift from end to the middle of the year
dfa.info()

x = np.arange(0,len(dfa.index))  # vectors x and y for trend calculation
y=dfa['IWV'].values

slope, intercept, r, p, std_err = stats.linregress(x,y)
dfa['fitted'] = myfunc(x, slope, intercept)

print("trend or slope: ", slope)    # unit mm/year  or kg/m**2
print("uncertainty of trend: ", std_err)
slope10=10*slope  # for unit mm/decade
err10=10*std_err


fig, axs= plt.subplots(1,1, sharex=True)
tstr='IWV trend at Bern: ' + str(np.round(slope10,decimals=2)) +' +/- ' + str(np.round(err10,decimals=2)) + ' mm/decade' 
fig.suptitle(tstr)
axs.set_ylabel('IWV (mm)')
df['IWV'].plot(ax=axs)       #  monthly means
dfa['fitted'].plot(ax=axs)   # straight line fit
dfa.plot(ax=axs)    # annual averages

plt.show()

fig.savefig('test.pdf')







