import matplotlib.pyplot as plt
import pandas as pd
from sklearn.linear_model import LinearRegression
import numpy as np
# read csv data++++++++++++++++++++++++++++++++++++++++++++++
IWV_series=pd.read_csv('iwv_Bern.csv',index_col='Date',parse_dates=True)
# Read csv data, use ‘Date’ as index
#                         IWV
#Date
#1995-01-16 13:00:00   7.3736
#1995-02-14 23:00:00  10.2056
#1995-03-16 10:00:00   7.7730
# resample+++++++++++++++++++++++++++++++++++++++++++++++++++
resample= IWV_series.resample('Y').mean()
# Resample the data by years
#                  IWV
#Date
#1995-12-31  14.404875
#1996-12-31  13.629292
#1997-12-31  14.065108
#linear regression+++++++++++++++++++++++++++++++++++++++++++
model = LinearRegression() # Linear regression function
Date=resample.index.year# Get the year of resampled 'Date'
IWV=resample.IWV.values# Resampled 'IWV'

Date=np.array(Date)
x=Date.reshape(-1,1)# Transform input data: LinearRegression need the input data is array and 2D

model.fit(x,IWV)# Fitting
y_pred = model.predict(x) # Get results: predicted response
print('slope:',model.coef_)


resample['fitted']=y_pred# write data to column
#plots+++++++++++++++++++++++++++++++++++++++++++++++++++++++
fig, axs= plt.subplots(1,1)
plt.ylabel('IWV(mm)')
IWV_series.plot(ax=axs)
resample['IWV'].plot(ax=axs)#The same x-axis, plotting data in DataFrame format
resample['fitted'].plot(ax=axs)
plt.show()








